<?php
require_once './../models/Cliente.php';
require_once './../helpers/ResponseHelper.php';
require_once './../helpers/ErrorHandler.php';
require_once './../helpers/RequestHandler.php';

class ClienteController
{

    public static function getAll()
    {

        RequestHandler::handle('GET', function () {
            $clients = Cliente::getAll();

            if ($clients) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Datos recuperados con éxito.",
                    "data" => $clients
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "GET",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se encontraron datos."
                ]);
            }
        });
    }

    public static function getTimestampOfLatestChange()
    {

        RequestHandler::handle('GET', function () {
            $latestTimestamp = Cliente::getTimestampOfLatestChange();

            if ($latestTimestamp) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Datos recuperados con éxito.",
                    "data" => $latestTimestamp
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "GET",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se encontraron datos."
                ]);
            }
        });
    }
}
