<?php
require_once __DIR__ . '/../models/Config.php';
require_once __DIR__ . '/../helpers/ResponseHelper.php';
require_once __DIR__ . '/../helpers/ErrorHandler.php';
require_once __DIR__ . '/../helpers/RequestHandler.php';

class ConfigController
{

    public static function getAppLatestVersion()
    {

        RequestHandler::handle('GET', function () {
            $appLatestVersion = Config::getAppLatestVersion();

            if ($appLatestVersion) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Datos recuperados con éxito.",
                    "data" => $appLatestVersion
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "GET",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se encontraron datos."
                ]);
            }
        });
    }
}
