<?php
require_once './../models/Mantenimiento.php';
require_once './../helpers/ResponseHelper.php';
require_once './../helpers/ErrorHandler.php';
require_once './../helpers/RequestHandler.php';

class MantenimientoController
{

    public static function getAll()
    {

        RequestHandler::handle('GET', function () {
            $maintenances = Mantenimiento::getAll();

            if ($maintenances) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Datos recuperados con éxito.",
                    "data" => $maintenances
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "GET",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se encontraron datos."
                ]);
            }
        });
    }

    public static function getByTabletId($tabletId)
    {
        RequestHandler::handle('GET', function () use ($tabletId) {
            $maintenance = Mantenimiento::getByTabletId($tabletId);

            if ($maintenance) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Registro recuperado con éxito.",
                    "data" => $maintenance
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "GET",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se encontró el registro."
                ]);
            }
        });
    }

    public static function getLatestByEquipoActivoFijo($equipoActivoFijo)
    {
        RequestHandler::handle('GET', function () use ($equipoActivoFijo) {
            $maintenance = Mantenimiento::getLatestByEquipoActivoFijo($equipoActivoFijo);

            if ($maintenance) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Registro recuperado con éxito.",
                    "data" => $maintenance
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "GET",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se encontró el registro."
                ]);
            }
        });
    }
}
