<?php
require_once __DIR__ . '/../models/Programacion.php';
require_once __DIR__ . '/../helpers/ResponseHelper.php';
require_once __DIR__ . '/../helpers/ErrorHandler.php';
require_once __DIR__ . '/../helpers/RequestHandler.php';

class ProgramacionController
{

    public static function getAll()
    {

        RequestHandler::handle('GET', function () {
            $programmings = Programacion::getAll();

            if ($programmings) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Datos recuperados con éxito.",
                    "data" => $programmings
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "GET",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se encontraron datos."
                ]);
            }
        });
    }

    public static function getByTecnicoId($id)
    {

        RequestHandler::handle('GET', function () use ($id) {
            $programmings = Programacion::getByTecnicoId($id);

            if ($programmings) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Datos recuperados con éxito.",
                    "data" => $programmings
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "GET",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se encontraron datos."
                ]);
            }
        });
    }

    public static function done($id)
    {

        RequestHandler::handle('POST', function () use ($id) {
            $done = Programacion::done($id);

            if ($done) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Programación actualizada con éxito."
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "POST",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se pudo actualizar la programación."
                ]);
            }
        });
    }
}
