<?php
require_once __DIR__ . '/../models/Tarea.php';
require_once __DIR__ . '/../helpers/ResponseHelper.php';
require_once __DIR__ . '/../helpers/ErrorHandler.php';
require_once __DIR__ . '/../helpers/RequestHandler.php';

class TareaController
{
    public static function getAll()
    {

        RequestHandler::handle('GET', function () {
            $tareas = Tarea::getAll();

            if ($tareas) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Datos recuperados con éxito.",
                    "data" => $tareas
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "GET",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se encontraron datos."
                ]);
            }
        });
    }

    public static function getTimestampOfLatestChange()
    {

        RequestHandler::handle('GET', function () {
            $latestTimestamp = Tarea::getTimestampOfLatestChange();

            if ($latestTimestamp) {
                ResponseHelper::sendResponse(200, [
                    "message" => "Datos recuperados con éxito.",
                    "data" => $latestTimestamp
                ], [
                    "Content-Type" => "application/json",
                    "Access-Control-Allow-Origin" => "*",
                    "Access-Control-Allow-Methods" => "GET",
                ]);
            } else {
                ResponseHelper::sendResponse(404, [
                    "message" => "No se encontraron datos."
                ]);
            }
        });
    }
}
