<?php

class RequestHandler
{
    public static function handle($method, $handler)
    {
        if ($_SERVER['REQUEST_METHOD'] !== $method) {
            ResponseHelper::sendResponse(405, [
                "message" => "Método HTTP no permitido. Solo se permite $method."
            ], [
                'Allow' => $method
            ]);
            return;
        }

        try {
            $handler();
        } catch (PDOException $e) {
            ErrorHandler::handleServerError($e);
        } catch (Exception $e) {
            ErrorHandler::handleServerError($e);
        }
    }
}
