<?php
require_once './../database.php';


class Cliente
{
    function __construct() {}

    /**
     * Retrieves all clients from the database.
     *
     * @return array|false An array of clients, or false if an error occurs.
     */
    public static function getAll()
    {

        $data = [];

        $query = "SELECT * FROM cliente ORDER BY dCliFecha_Act DESC";

        try {

            $cmd = Database::getInstance()->getDb()->prepare($query);

            $cmd->execute();

            $data = $cmd->fetchAll(PDO::FETCH_ASSOC);

            return $data;
        } catch (PDOException $e) {

            return false;
        }
    }

    public static function getTimestampOfLatestChange()
    {
        $query = "SELECT timestamp FROM audit WHERE sNombreTabla = 'cliente' ORDER BY timestamp DESC LIMIT 1";

        try {

            $cmd = Database::getInstance()->getDb()->prepare($query);

            $cmd->execute();

            $data = $cmd->fetchAll(PDO::FETCH_ASSOC);

            return $data;
        } catch (PDOException $e) {

            return false;
        }
    }
}
