<?php
require_once __DIR__ . '/../database.php';


class Contrato
{
    function __construct() {}

    /**
     * Retrieves all contracts from the database.
     *
     * @return array|false An array of contracts with their details, or false if an error occurs.
     */
    public static function getAll()
    {

        $query = "SELECT * FROM contrato WHERE dConFechaTermino >= CURDATE() AND nConEliminado = 0 ORDER BY dConFecha DESC";

        try {

            $cmd = Database::getInstance()->getDb()->prepare($query);

            $cmd->execute();

            $data = $cmd->fetchAll(PDO::FETCH_ASSOC);

            return $data;
        } catch (PDOException $e) {

            return false;
        }
    }

    public static function getAllWithDetails()
    {

        $data = [];

        $query = "SELECT * FROM contrato WHERE dConFechaTermino >= CURDATE() ORDER BY dConFecha DESC ";

        try {

            $cmd = Database::getInstance()->getDb()->prepare($query);

            $cmd->execute();

            $data = $cmd->fetchAll(PDO::FETCH_ASSOC);

            foreach ($data as $key => $value) {
                $query = "SELECT * FROM detalle_contrato WHERE nContrato_Id = ?";
                $cmd = Database::getInstance()->getDb()->prepare($query);
                $cmd->execute(array($value['Contrato_Id']));
                $data[$key]['details'] = $cmd->fetchAll(PDO::FETCH_ASSOC);
            }

            return $data;
        } catch (PDOException $e) {

            return false;
        }
    }

    public static function getTimestampOfLatestChange()
    {
        $query = "SELECT timestamp FROM audit WHERE sNombreTabla = 'contrato' ORDER BY timestamp DESC LIMIT 1";

        try {

            $cmd = Database::getInstance()->getDb()->prepare($query);

            $cmd->execute();

            $data = $cmd->fetchAll(PDO::FETCH_ASSOC);

            return $data;
        } catch (PDOException $e) {

            return false;
        }
    }
}
