<?php
require_once __DIR__ . '/../database.php';


class Programacion
{
    function __construct() {}


    public static function getAll()
    {

        $data = [];

        $query = "SELECT * FROM programacion ORDER BY dProFecha DESC";

        try {

            $cmd = Database::getInstance()->getDb()->prepare($query);

            $cmd->execute();

            $data = $cmd->fetchAll(PDO::FETCH_ASSOC);

            return $data;
        } catch (PDOException $e) {

            return false;
        }
    }

    public static function getByTecnicoId($id)
    {

        $data = [];

        $query = "SELECT * FROM programacion WHERE nProTecnico_Id = ? AND nProEstado = 1 ORDER BY dProFecha ASC";

        try {

            $cmd = Database::getInstance()->getDb()->prepare($query);

            $cmd->execute(array($id));

            $data = $cmd->fetchAll(PDO::FETCH_ASSOC);

            return $data;
        } catch (PDOException $e) {

            return false;
        }
    }

    public static function done($id)
    {
        // Estados
        // 0: Anulado
        // 1: Programado
        // 2: Realizado

        $query = "UPDATE programacion SET nProEstado = 2 WHERE Programacion_Id = ?";

        try {

            $cmd = Database::getInstance()->getDb()->prepare($query);

            $cmd->execute([$id]);

            return true;
        } catch (PDOException $e) {

            return false;
        }
    }
}
