<?php

require_once './../controllers/MantenimientoController.php';
require_once './../controllers/ContratoController.php';
require_once './../controllers/DetalleContratoController.php';
require_once './../controllers/ClienteController.php';
require_once './../controllers/ProgramacionController.php';
require_once './../controllers/ConfigController.php';
require_once './../controllers/MatrizController.php';
require_once './../controllers/PlanDetalleTareasController.php';
require_once './../controllers/PlantillaController.php';
require_once './../controllers/EquipoController.php';
require_once './../controllers/TareaSistemaController.php';
require_once './../controllers/TareaController.php';
require_once './../controllers/SistemaController.php';
require_once './../helpers/ResponseHelper.php';
require_once './../models/Router.php';
require_once './../config/constants.php';

$router = new Router(BASE_PATH);
$mantenimientoController = new MantenimientoController();
$contratoController = new ContratoController();
$detalleContratoController = new DetalleContratoController();
$clienteController = new ClienteController();
$programacionController = new ProgramacionController();
$configController = new ConfigController();
$matrizController = new MatrizController();
$planDetalleTareasController = new PlanDetalleTareasController();
$plantillaController = new PlantillaController();
$equipoController = new EquipoController();
$tareaSistemaController = new TareaSistemaController();
$tareaController = new TareaController();
$sistemaController = new SistemaController();

$router->register('GET', '/mantenimientos', function () use ($mantenimientoController) {

    $mantenimientoController->getAll();
});

$router->register('GET', '/mantenimientos/{param}', function ($param) use ($mantenimientoController) {

    $mantenimientoController->getByTabletId($param);
});

$router->register('GET', '/mantenimientos/ultimo/equipo/{param}', function ($param) use ($mantenimientoController) {

    $mantenimientoController->getLatestByEquipoActivoFijo($param);
});

$router->register('GET', '/metadata/app/latest-version', function () use ($configController) {

    $configController->getAppLatestVersion();
});

// Timestamp's routes of latest changes

$router->register('GET', '/listener/latest-change/matriz', function () use ($matrizController) {

    $matrizController->getTimestampOfLatestChange();
});

$router->register('GET', '/listener/latest-change/pla_detalle_tareas', function () use ($planDetalleTareasController) {

    $planDetalleTareasController->getTimestampOfLatestChange();
});

$router->register('GET', '/listener/latest-change/plantillas', function () use ($plantillaController) {

    $plantillaController->getTimestampOfLatestChange();
});

$router->register('GET', '/listener/latest-change/equipos', function () use ($equipoController) {

    $equipoController->getTimestampOfLatestChange();
});

$router->register('GET', '/listener/latest-change/tarea_sistema', function () use ($tareaSistemaController) {

    $tareaSistemaController->getTimestampOfLatestChange();
});

$router->register('GET', '/listener/latest-change/tareas', function () use ($tareaController) {

    $tareaController->getTimestampOfLatestChange();
});

$router->register('GET', '/listener/latest-change/sistema', function () use ($sistemaController) {

    $sistemaController->getTimestampOfLatestChange();
});

$router->register('GET', '/listener/latest-change/contrato', function () use ($contratoController) {

    $contratoController->getTimestampOfLatestChange();
});

$router->register('GET', '/listener/latest-change/detalle_contrato', function () use ($detalleContratoController) {

    $detalleContratoController->getTimestampOfLatestChange(); 
});

$router->register('GET', '/listener/latest-change/cliente', function () use ($clienteController) {

    $clienteController->getTimestampOfLatestChange();
});

// Sync routes

$router->register('GET', '/matriz', function () use ($matrizController) {

    $matrizController->getAll();
});

$router->register('GET', '/pla_detalle_tareas', function () use ($planDetalleTareasController) {

    $planDetalleTareasController->getAll();
});

$router->register('GET', '/plantillas', function () use ($plantillaController) {

    $plantillaController->getAll();
});

$router->register('GET', '/equipos', function () use ($equipoController) {

    $equipoController->getAll();
});

$router->register('GET', '/tarea_sistema', function () use ($tareaSistemaController) {

    $tareaSistemaController->getAll();
});

$router->register('GET', '/tareas', function () use ($tareaController) {

    $tareaController->getAll();
});

$router->register('GET', '/sistema', function () use ($sistemaController) {

    $sistemaController->getAll();
});

/**Deprecated GET /contratos route in 3.0.0 App Version */
$router->register('GET', '/contratos', function () use ($contratoController) {

    $contratoController->getAllWithDetails();
});

$router->register('GET', '/contrato', function () use ($contratoController) {

    $contratoController->getAll();
});

$router->register('GET', '/detalle_contrato', function () use ($detalleContratoController) {

    $detalleContratoController->getAll();
});

/**Deprecated GET /clientes route in 3.0.0 App Version */
$router->register('GET', '/clientes', function () use ($clienteController) {

    $clienteController->getAll();
});

$router->register('GET', '/cliente', function () use ($clienteController) {

    $clienteController->getAll();
});

$router->register('GET', '/programaciones/tecnico/{param}', function ($param) use ($programacionController) {

    $programacionController->getByTecnicoId($param);
});

//

$router->dispatch();
